GLOBAL_CONFIG.client_time = GLOBAL_CONFIG.client_time or NOW_TIME

local check_update = {
	task_status = 0,
}

function check_update:Name()
	return "check_update"
end

function check_update:Start()
	self:CleanOldAsset()

	local update_pkg = GLOBAL_CONFIG.param_list.switch_list.update_package
	local old_pkg_ver = string.gsub(GLOBAL_CONFIG.package_info.version or '', '%.', '')
	old_pkg_ver = tonumber(old_pkg_ver) or 0
	local new_pkg_ver = string.gsub(GLOBAL_CONFIG.version_info.package_info.version or '', '%.', '')
	new_pkg_ver = tonumber(new_pkg_ver) or 0

	if update_pkg and new_pkg_ver > old_pkg_ver then
		local msg = tostring(GLOBAL_CONFIG.version_info.package_info.msg) or  "版本过低，请下载安装最新安装包"
		local dialog_format = { cancelable = false, title = "版本更新", message = msg, positive = "下载", negative = "退出", }

		PlatformAdapter:OpenAlertDialog(dialog_format, LUA_CALLBACK(self, self.DialogCallback))
		self.task_status = MainLoader.TASK_STATUS_FINE
	else
		local version_text = cjson.encode(GLOBAL_CONFIG.version_info.assets_info) or ""
		UtilEx:writeText(UtilEx:getDataPath() .. "temp/version.txt", version_text)

		MainLoader:PushTask(require("scripts/preload/asset_update"))
		self.task_status = MainLoader.TASK_STATUS_DONE
	end

	MainProber:Step(MainProber.STEP_TASK_CHECK_UPDATE_BEG, old_pkg_ver, new_pkg_ver, update_pkg)
end

function check_update:Update()
	return self.task_status
end

function check_update:Stop()
	self.task_status = -1
	
	MainProber:Step(MainProber.STEP_TASK_CHECK_UPDATE_END)
end

function check_update:DialogCallback(result)
	if "positive" == result then
		PlatformAdapter:OpenBrowser(GLOBAL_CONFIG.version_info.package_info.url)
	else
		AdapterToLua:endGame()
	end
end

function check_update:CleanOldAsset()
	local saved_version = UtilEx:readText(UtilEx:getDataPath() .. "version.pkg")

	if tostring(saved_version) ~= tostring(GLOBAL_CONFIG.package_info.version) then
		UtilEx:removeFile(UtilEx:getDataPath() .. "main/")
		UtilEx:removeFile(UtilEx:getDataPath() .. "temp/")
		UtilEx:removeFile(UtilEx:getDataPath() .. "config.txt")

		UtilEx:writeText(UtilEx:getDataPath() .. "version.pkg", tostring(GLOBAL_CONFIG.package_info.version))
	end
end

return check_update
